<?php

if (!defined('FORUM'))
	die();

function update_users_rating($ids)
{
	global $forum_db;
	
	@set_time_limit(0);
	$rating_query = array(
		'SELECT'	=>	'p.poster_id, SUM(p.rating) AS user_rating',
		'FROM'		=>	'posts AS p',
		'GROUP BY'	=>	'p.poster_id'
	);
	$rating_res = $forum_db->query_build($rating_query) or error(__FILE__, __LINE__);

	if ($forum_db->num_rows($rating_res) > 0)
	{
		$rating_update_query = array(
			'UPDATE'	=>	'users',
			'SET'		=>	'rating = NULL'
		);
		$forum_db->query_build($rating_update_query) or error(__FILE__, __LINE__);
			
		while ($cur_rating = $forum_db->fetch_assoc($rating_res))
		{
            if ($cur_rating['user_rating'] != '') { $new_rating = $cur_rating['user_rating']; } else { $new_rating = 'NULL'; }
			
			$rating_update_query = array(
				'UPDATE'	=>	'users',
				'SET'		=>	'rating = '.$new_rating,
				'WHERE'		=>	'id = '.$cur_rating['poster_id']
			);
			$forum_db->query_build($rating_update_query) or error(__FILE__, __LINE__);
		}
	}
	
	if (is_array($ids)) 
	{
		$query = array(
		    'DELETE'	=>	'rating',
		    'WHERE'		=>	'post_id IN('.implode(',', $ids).')',
	    );
	    $forum_db->query_build($query) or error(__FILE__, __LINE__);
	}
	else
	{
		$query = array(
		    'DELETE'	=>	'rating',
		    'WHERE'		=>	'post_id='.$ids
	    );
	    $forum_db->query_build($query) or error(__FILE__, __LINE__);
	}
}

function update_topic_field()
{
	global $forum_db;
	
	@set_time_limit(0);
	$rating_query = array(
		'SELECT'	=>	'r.id, p.topic_id',
		'FROM'		=>	'rating AS r',
		'JOINS'		=> array(
			array(
				'LEFT JOIN'		=> 'posts AS p',
				'ON'		    => 'p.id=r.post_id',
			)
		),
	);
	$res = $forum_db->query_build($rating_query) or error(__FILE__, __LINE__);

	if ($forum_db->num_rows($res) > 0)
	{
		while ($cur_rating = $forum_db->fetch_assoc($res))
		{
            if ($cur_rating['topic_id'] != '') { $topic_id = $cur_rating['topic_id']; } else { $topic_id = 0; }
			
			$rating_update_query = array(
				'UPDATE'	=>	'rating',
				'SET'		=>	'topic_id = '.$topic_id,
				'WHERE'		=>	'id = '.$cur_rating['id']
			);
			$forum_db->query_build($rating_update_query) or error(__FILE__, __LINE__);
		}
	}
}
?>