<?php

if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', '../../');
require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/index.php';

if (file_exists(FORUM_ROOT.'extensions/rating/lang/'.$forum_user['language'].'/rating.php'))
	require FORUM_ROOT.'extensions/rating/lang/'.$forum_user['language'].'/rating.php';
else
	require FORUM_ROOT.'extensions/rating/lang/English/rating.php';

$max_items = ($forum_config['o_rating_num_entries_per_page'] > 0) ? $forum_config['o_rating_num_entries_per_page'] : $forum_user['disp_posts'];
$section = isset($_GET['section']) ? $_GET['section'] : 'top_topics';

if ($section == 'top_topics' || $section == 'top_posts' || $section == 'top_users' || $section == 'last_changes') {
    $forum_page['main_menu'] = array();
	$forum_page['main_menu']['top_topics'] = '<li class="first-item'.(($section == 'top_topics') ? ' active' : '').'"><a href="'.forum_link($forum_url['rating_section'], 'top_topics').'"><span>'.$lang_rating['Top topics'].'</span></a></li>';
    $forum_page['main_menu']['top_posts'] = '<li'.(($section == 'top_posts') ? ' class="active"' : '').'><a href="'.forum_link($forum_url['rating_section'], 'top_posts').'"><span>'.$lang_rating['Top posts'].'</span></a></li>';
    $forum_page['main_menu']['top_users'] = '<li'.(($section == 'top_users') ? ' class="active"' : '').'><a href="'.forum_link($forum_url['rating_section'], 'top_users').'"><span>'.$lang_rating['Top users'].'</span></a></li>';
    $forum_page['main_menu']['last_changes'] = '<li'.(($section == 'last_changes') ? ' class="active"' : '').'><a href="'.forum_link($forum_url['rating_section'], 'last_changes').'"><span>'.$lang_rating['Last changes'].'</span></a></li>';
}

switch ($section)
{
	case 'top_topics':
	{
        if ($forum_config['o_rating_calculation_topic_rating'] == '1') {
		    $query = array(
		        'SELECT'	=> 't.id',
		        'FROM'		=> 'posts AS p',
		        'JOINS'		=> array(
			        array(
				        'LEFT JOIN'		=> 'topics AS t',
				        'ON'		    => 't.id=p.topic_id',
			        ),
		        ),
			    'WHERE'     => 'p.rating IS NOT NULL AND p.rating > 0',
                'GROUP BY'  => 't.id'
	        );
		} else {	
		    $query = array(
		        'SELECT'	=> 't.id',
		        'FROM'		=> 'topics AS t',
		        'JOINS'		=> array(
				    array(
				        'LEFT JOIN'		=> 'posts AS p',
				        'ON'		    => 'p.id=t.first_post_id',
			        ),
		        ),
			    'WHERE'     => 'p.rating IS NOT NULL AND p.rating > 0',
	        );	
		}
		
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	    $total = $forum_db->num_rows($result);
	
$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array(sprintf($lang_rating['Rating']), forum_link($forum_url['rating'])),
	$lang_rating['Top topics']
);

$forum_page['main_head'] = end($forum_page['crumbs']);

define('FORUM_PAGE', 'rating-top_topics');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

?>  
<div class="main-subhead">
	<h2 class="hn"><span><?php echo $forum_page['main_head'] ?></span></h2>
</div>
<div class="main-content main-frm">
<?php
    if ($total > 0) {
		if ($forum_config['o_rating_calculation_topic_rating'] == '1') {
		    $query = array(
		        'SELECT'	=> 't.id, t.poster, t.subject as topic_title, p.poster_id, SUM(p.rating) as topic_rating',
		        'FROM'		=> 'posts AS p',
		        'JOINS'		=> array(
			        array(
				        'LEFT JOIN'		=> 'topics AS t',
				        'ON'		    => 't.id=p.topic_id',
			        ),
		        ),
			    'WHERE'     => 'p.rating IS NOT NULL AND p.rating > 0',
                'GROUP BY'  => 't.id',
				'ORDER BY'	=> 'topic_rating DESC',
			    'LIMIT'		=> $max_items
	        );
		} else {
		    $query = array(
		        'SELECT'	=> 't.id, t.poster, t.subject as topic_title, p.poster_id, p.rating as topic_rating',
		        'FROM'		=> 'topics AS t',
		        'JOINS'		=> array(
				    array(
				        'LEFT JOIN'		=> 'posts AS p',
				        'ON'		    => 'p.id=t.first_post_id',
			        ),
		        ),
			    'WHERE'     => 'p.rating IS NOT NULL AND p.rating > 0',
				'ORDER BY'	=> 'topic_rating DESC',
			    'LIMIT'		=> $max_items
	        );
		}
		
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
?>
    <div class="ct-group">
		<table>
			<thead>
				<tr>
					<th style="width:0.5em;"></th>
				    <th class="tc1" scope="col"><?php echo $lang_rating['Topic'] ?></th>
					<th class="tc1" scope="col" style="width:20em;"><?php echo $lang_rating['Author'] ?></th>
					<th class="tc3" scope="col" style="width:9em; text-align:center;"><?php echo $lang_rating['Rating'] ?></th>
				</tr>
        	</thead>
			<tbody>	
<?php
		    $i = 1;
		    while ( $rating = $forum_db->fetch_assoc($result) )
		    {
			    if ($rating['poster'] == 'Guest') {$username = $lang_rating['Guest'];} else {$username = '<a href="'.forum_link($forum_url['user'], $rating['poster_id']).'">'.$rating['poster'].'</a>';}
				$topic_rating = isset($rating['topic_rating']) ? $rating['topic_rating'] : '0';
				
			    echo '
			        <tr>
				        <td>'.$i.'</td>
				        <td class="tc1"><a href="'.forum_link($forum_url['rating_topic'], $rating['id']).'" title="'.$rating['topic_title'].'">'.$rating['topic_title'].'</a></td>
				        <td class="tc1">'.$username.'</td>
				        <td class="tc3" style=" text-align:center;">'.$topic_rating.'</td>
				    </tr>';

	            $i++;
		    }		
?>
		    </tbody>
		</table>
	</div>
</div>
<?php
    } else {
?>
    <div class="ct-box" style="background:#FEFFE6 none repeat scroll 0% 0%;">
		<p><strong><?php echo $lang_rating['No ratings found'] ?></strong></p>
	</div>
</div>
<?php	
	}
	
	break;
	}
	
	case 'top_posts':
	{
        $query = array(
		    'SELECT'	=> 'id',
		    'FROM'		=> 'rating'
	    );
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	    $total = $forum_db->num_rows($result);
	
$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array(sprintf($lang_rating['Rating']), forum_link($forum_url['rating'])),
	$lang_rating['Top posts']
);

$forum_page['main_head'] = end($forum_page['crumbs']);

define('FORUM_PAGE', 'rating-top_posts');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

?>  
<div class="main-subhead">
	<h2 class="hn"><span><?php echo $forum_page['main_head'] ?></span></h2>
</div>
<div class="main-content main-frm">
<?php
    if ($total > 0) {
		$query = array(
		    'SELECT'	=> 'p.id, p.poster, p.poster_id, p.rating, t.subject as topic_title',
		    'FROM'		=> 'posts AS p',
		    'JOINS'		=> array(
			    array(
				    'LEFT JOIN'		=> 'topics AS t',
				    'ON'		    => 't.id=p.topic_id',
			    )
		    ),
			'WHERE'	    => 'p.rating IS NOT NULL AND p.rating > 0',
	        'ORDER BY'	=> 'p.rating DESC',
			'LIMIT'		=> $max_items
	    );
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
?>
    <div class="ct-group">
		<table>
			<thead>
				<tr>
					<th style="width:0.5em;"></th>
				    <th class="tc1" scope="col"><?php echo $lang_rating['Post'] ?></th>
					<th class="tc1" scope="col" style="width:20em;"><?php echo $lang_rating['Author'] ?></th>
					<th class="tc3" scope="col" style="width:9em; text-align:center;"><?php echo $lang_rating['Rating'] ?></th>
				</tr>
        	</thead>
			<tbody>	
<?php
		    $i = 1;
		    while ( $rating = $forum_db->fetch_assoc($result) )
		    {
			if ($rating['poster_id'] > 1) {$username = '<a href="'.forum_link($forum_url['user'], $rating['poster_id']).'">'.$rating['poster'].'</a>';} else {$username = $rating['poster'];}
			
			    echo '
			        <tr>
				        <td>'.$i.'</td>
				        <td class="tc1"><a href="'.forum_link($forum_url['rating_post'], $rating['id']).'">'.$rating['topic_title'].'</a></td>
				        <td class="tc1">'.$username.'</td>
				        <td class="tc3" style=" text-align:center;">'.$rating['rating'].'</td>
				    </tr>';

	            $i++;
		    }		
?>
		    </tbody>
		</table>
	</div>
</div>
<?php
    } else {
?>
    <div class="ct-box" style="background:#FEFFE6 none repeat scroll 0% 0%;">
		<p><strong><?php echo $lang_rating['No ratings found'] ?></strong></p>
	</div>
</div>
<?php	
	}
	
	break;
	}
	
	case 'top_users':
	{
        $query = array(
		    'SELECT'	=> 'id',
		    'FROM'		=> 'rating'
	    );
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	    $total = $forum_db->num_rows($result);
	
$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array(sprintf($lang_rating['Rating']), forum_link($forum_url['rating'])),
	$lang_rating['Top users']
);

$forum_page['main_head'] = end($forum_page['crumbs']);

define('FORUM_PAGE', 'rating-top_users');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

?>  
<div class="main-subhead">
	<h2 class="hn"><span><?php echo $forum_page['main_head'] ?></span></h2>
</div>
<div class="main-content main-frm">
<?php
    if ($total > 0) {
		$query = array(
		    'SELECT'	=> 'u.id, u.username, u.rating',
		    'FROM'		=> 'users AS u',
			'JOINS'		=> array(
			    array(
				    'LEFT JOIN'	 => 'groups AS g',
				    'ON'		 => 'g.g_id=u.group_id'
			    ),
		    ),
			'WHERE'	    => 'u.id > 1 AND u.rating IS NOT NULL AND g.g_rating_enable = 1 AND u.rating_enable = 1 AND u.rating_disable_adm = 0',
	        'ORDER BY'	=> 'u.rating DESC',
			'LIMIT'		=> $max_items
	    );
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
?>
    <div class="ct-group">
		<table>
			<thead>
				<tr>
					<th style="width:0.5em;"></th>
				    <th class="tc1" scope="col"><?php echo $lang_rating['User'] ?></th>
					<th class="tc3" scope="col" style="width:9em; text-align:center;"><?php echo $lang_rating['Rating'] ?></th>
				</tr>
        	</thead>
			<tbody>	
<?php
		    $i = 1;
		    while ( $rating = $forum_db->fetch_assoc($result) )
		    {
			    $username = '<a href="'.forum_link($forum_url['rating_user'], $rating['id']).'">'.$rating['username'].'</a>';
				
			    echo '
			        <tr>
				        <td>'.$i.'</td>
				        <td class="tc1">'.$username.'</td>
				        <td class="tc3" style=" text-align:center;">'.$rating['rating'].'</td>
				    </tr>';

	            $i++;
		    }		
?>
		    </tbody>
		</table>
	</div>
</div>
<?php
    } else {
?>
    <div class="ct-box" style="background:#FEFFE6 none repeat scroll 0% 0%;">
		<p><strong><?php echo $lang_rating['No ratings found'] ?></strong></p>
	</div>
</div>
<?php	
	}
	
	break;
	}
	
	case 'last_changes':
	{
        $query = array(
		    'SELECT'	=> 'id',
		    'FROM'		=> 'rating'
	    );
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	    $total = $forum_db->num_rows($result);
		
		if ($total > 0) {
	        $query = array(
		        'SELECT'	=> 'SUM(r.rating) as rating',
		        'FROM'		=> 'rating AS r',
		        'WHERE'		=> 'rating=\'1\''
	        );
	        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	        $up = $forum_db->fetch_assoc($result);

	        $rating_up = $up['rating'];
	        $rating_down = $total - $rating_up;
//	        $rating_all_rates = '<b>'.$total.'</b> [<b>+'.$rating_up.'</b> | <b>-'.$rating_down.'</b>]';
            $rating_all_rates = '<b>'.$total.' [+'.$rating_up.' | -'.$rating_down.']</b>';
		}
	
$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array(sprintf($lang_rating['Rating']), forum_link($forum_url['rating'])),
	$lang_rating['Last changes rating']
);

$forum_page['main_head'] = end($forum_page['crumbs']);

define('FORUM_PAGE', 'rating-last_changes');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

?>  
<div class="main-subhead">
	<h2 class="hn"><span><?php echo $forum_page['main_head'] ?></span><span style="float:right;"><?php if ($total > 0)  echo $lang_rating['Total rates'] . $rating_all_rates; ?></span></h2>
</div>
<div class="main-content main-frm">
<?php
    if ($total > 0) {
		$query = array(
		    'SELECT'	=> 'r.post_id, r.rating, r.updated_at, t.subject AS topic_title, u.id AS user_id, u.username AS user',
		    'FROM'		=> 'rating AS r',
		    'JOINS'		=> array(
			    array(
				    'LEFT JOIN'		=> 'topics AS t',
				    'ON'		    => 't.id=r.topic_id',
			    ),
				array(
				    'LEFT JOIN'		=> 'users AS u',
				    'ON'		    => 'u.id=r.user_id',
			    )
		    ),
	        'ORDER BY'	=> 'r.updated_at DESC',
			'LIMIT'		=> $max_items
	    );
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
?>
    <div class="ct-group">
		<table>
			<thead>
				<tr>
				    <th class="tc0" scope="col" style="width:20em;"><?php echo $lang_rating['Voted'] ?></th>
					<th class="tc4" scope="col" style="width:5em; text-align:center;"><?php echo $lang_rating['Mark'] ?></th>
					<th class="tc1" scope="col"><?php echo $lang_rating['Post'] ?></th>
					<th class="tc5" scope="col" style="width:10.4em;"><?php echo $lang_rating['Date'] ?></th>
				</tr>
        	</thead>
			<tbody>	
<?php
		    $i = 0;
		    while ( $rating = $forum_db->fetch_assoc($result) )
		    {
			    if (empty($rating['user'])) {$username = $lang_rating['User deleted'];} elseif ($rating['user'] == 'Guest') {$username = $lang_rating['Guest'];} else {$username = '<a href="'.forum_link($forum_url['user'], $rating['user_id']).'">'.$rating['user'].'</a>';}
				
			    echo '
			        <tr>
				        <td class="tc0">'.$username.'</td>
				        <td class="tc4" style="text-align:center;">'.$rating['rating'].'</td>
				        <td class="tc1"><a href="'.forum_link($forum_url['post'], $rating['post_id']).'" title="'.$rating['topic_title'].'">'.$rating['topic_title'].'</a></td>
				        <td class="tc5">'.format_time($rating['updated_at']).'</td>
				    </tr>';

	            $i++;
		    }		
			
			if ($total > $max_items) {
			    $latest_marks = '<strong>'.$max_items.' </strong>'.$lang_rating['Latest marks'].'<b> '.$total.'</b>';
			} else {
				$latest_marks = '<strong>'.$i.' </strong>'.$lang_rating['Marks from'].'<b> '.$i.'</b>';
			}
?>
		    </tbody>
		</table>
	</div>
	<div class="main-subhead">
        <h2 class="hn"><span><?php echo $latest_marks ?></span></h2>
    </div>
</div>
<?php
    } else {
?>
    <div class="ct-box" style="background:#FEFFE6 none repeat scroll 0% 0%;">
		<p><strong><?php echo $lang_rating['No ratings found'] ?></strong></p>
	</div>
</div>
<?php	
	}
	
	break;
	}
	
	case 'topic':
	{
        $topic_id = isset($_GET['id']) ? intval($_GET['id']) : 0;
	
	    $query_t = array(
		    'SELECT'	=> 'id',
		    'FROM'		=> 'topics',
		    'WHERE'		=> 'id=\''.$forum_db->escape($topic_id).'\''
	    );
	    $result_t = $forum_db->query_build($query_t) or error(__FILE__, __LINE__);
		$t_rating = $forum_db->num_rows($result_t);
	
	    if ($t_rating == 1) {
			$query = array(
		        'SELECT'	=> 'COUNT(id) AS count, SUM(rating) as rating, SUM(CASE WHEN rating = 1 THEN 1 ELSE 0 END) as up',
		        'FROM'		=> 'rating',
			    'WHERE'		=> 'topic_id=\''.$forum_db->escape($topic_id).'\''
	        );
	        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			$topic = $forum_db->fetch_assoc($result);
		
		    if ($topic['count'] > 0) {
	            $total = $topic['count'];
				
				$forum_page['num_pages'] = ceil($total / $max_items);
	            $forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
	            $forum_page['start_from'] = $max_items * ($forum_page['page'] - 1);
	            $forum_page['finish_at'] = min(($forum_page['start_from'] + $max_items), ($total));
	            $forum_page['items_info'] = generate_items_info($lang_rating['Marks from'], ($forum_page['start_from'] + 1), $total);
	            if ($forum_page['num_pages'] > 1)
		            $forum_page['page_post']['paging'] = '<p class="paging"><span class="pages">'.$lang_rating['Pages'].'</span> '.paginate($forum_page['num_pages'], $forum_page['page'], str_replace($base_url,"",forum_link($forum_url['rating_topic'], $topic_id)), ' ').'</p>';

	            $topic_rating = $topic['rating'];
				$rating_up = $topic['up'];
	            $rating_down = $total - $rating_up;
	            $rating_topic_rates = ' <b>'.$topic_rating.' [+'.$rating_up.' | -'.$rating_down.']</b>';
	        } else {
		        $rating_topic_rates = ' <b>0</b>';
			    $total = 0;
	        }
		
		    $topic_rating = '№ '.$topic_id;

	    } else {
		    $topic_rating = '';
		    $rating_topic_rates = ' <b>0</b>';
	        $total = 0;
	    }
		
$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array(sprintf($lang_rating['Rating']), forum_link($forum_url['rating'])),
	sprintf($lang_rating['Rating of topic'], $topic_rating)
);

$forum_page['main_head'] = end($forum_page['crumbs']);

define('FORUM_PAGE', 'rating-topic_rating');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

?>  
<div class="main-head">
	<h2 class="hn"><span><?php echo $forum_page['main_head'] ?></span><span style="float:right; margin-right:-10em;"><?php echo $lang_rating['User Rating'] . $rating_topic_rates ?></span></h2>
</div>
<div class="main-content main-frm">
<?php
	if ($total > 0) {
		$query = array(
		    'SELECT'	=> 'r.post_id, r.rating, r.updated_at, r.user_id, t.subject AS topic_title, u.username',
		    'FROM'		=> 'rating AS r',
		    'JOINS'		=> array(
			    array(
				    'LEFT JOIN'		=> 'topics AS t',
				    'ON'		    => 't.id=r.topic_id',
			    ),
				array(
				    'LEFT JOIN'		=> 'users AS u',
				    'ON'		    => 'u.id=r.user_id',
			    )
		    ),
			'WHERE'	    =>  'r.topic_id='.$topic_id,
            'ORDER BY'	=>  'r.updated_at DESC',
			'LIMIT'		=>  $forum_page['start_from'].', '.$max_items
	    );
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
?> 
    <div class="ct-group">
		<table>
			<thead>
				<tr>
				    <th class="tc0" scope="col" style="width:20em;"><?php echo $lang_rating['Voted'] ?></th>
					<th class="tc4" scope="col" style="width:5em; text-align:center;"><?php echo $lang_rating['Mark'] ?></th>
					<th class="tc1" scope="col"><?php echo $lang_rating['For post'] ?></th>
					<th class="tc5" scope="col" style="width:10.4em;"><?php echo $lang_rating['Date'] ?></th>
				</tr>
        	</thead>
			<tbody>	
<?php
		    $i = isset($_GET['p']) ? $max_items * ($forum_page['page']-1) : '0';
		    while ( $rating = $forum_db->fetch_assoc($result) )
		    {
			    if (empty($rating['username'])) {$username = $lang_rating['User deleted'];} elseif ($rating['username'] == 'Guest') {$username = $lang_rating['Guest'];} else {$username = '<a href="'.forum_link($forum_url['user'], $rating['user_id']).'">'.$rating['username'].'</a>';}

			    echo '
			        <tr>
				        <td class="tc0">'.$username.'</td>
				        <td class="tc4" style="text-align:center;">'.$rating['rating'].'</td>
				        <td class="tc1"><a href="'.forum_link($forum_url['post'], $rating['post_id']).'" title="'.$rating['topic_title'].'">'.$rating['topic_title'].'</a></td>
				        <td class="tc5">'.format_time($rating['updated_at']).'</td>
				    </tr>';

	            $i++;
		    }
			
		    if ($total <= $max_items) {
				$total_rates = $lang_rating['Total rates'].'<b> '.$total.'</b>';
			} else {
				$total_rates = '<b>'.$i.' </b>'.$lang_rating['Marks from'].'<b> '.$total.'</b>';
			}		
?>
		    </tbody>
		</table>
	</div>
	<div class="main-head">
        <h2 class="hn"><span><?php echo $total_rates ?></span></h2>
    </div>
</div>
<?php
    } else {
?>
    <div class="ct-box" style="background:#FEFFE6 none repeat scroll 0% 0%;">
		<p><strong><?php if ($t_rating == 1)  echo $lang_rating['No votes in topic'];  else  echo $lang_rating['Topic not found']; ?></strong></p>
	</div>
</div>
<?php	
	}
	
	break;
	}
	
	case 'post':
	{
        $post_id = isset($_GET['id']) ? intval($_GET['id']) : 0;

	    $query_p = array(
		    'SELECT'	=> 'id, rating',
		    'FROM'		=> 'posts',
		    'WHERE'		=> 'id=\''.$forum_db->escape($post_id).'\''
	    );
	    $result_p = $forum_db->query_build($query_p) or error(__FILE__, __LINE__);
		$p_rating = $forum_db->num_rows($result_p);
		
		if ($p_rating == 1) {
		    $ps_rating = $forum_db->fetch_assoc($result_p);

			$query = array(
		        'SELECT'	=> 'COUNT(id) AS count, SUM(CASE WHEN rating = 1 THEN 1 ELSE 0 END) as up',
		        'FROM'		=> 'rating',
			    'WHERE'		=> 'post_id=\''.$forum_db->escape($post_id).'\''
	        );
	        $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			$post = $forum_db->fetch_assoc($result);
			
			$total = $post['count'];

			$forum_page['num_pages'] = ceil($total / $max_items);
	        $forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
	        $forum_page['start_from'] = $max_items * ($forum_page['page'] - 1);
	        $forum_page['finish_at'] = min(($forum_page['start_from'] + $max_items), ($total));
	        $forum_page['items_info'] = generate_items_info($lang_rating['Marks from'], ($forum_page['start_from'] + 1), $total);
	        if ($forum_page['num_pages'] > 1)
		        $forum_page['page_post']['paging'] = '<p class="paging"><span class="pages">'.$lang_rating['Pages'].'</span> '.paginate($forum_page['num_pages'], $forum_page['page'], str_replace($base_url,"",forum_link($forum_url['rating_post'], $post_id)), ' ').'</p>';
	
	        $rating_up = $post['up'];
	        $rating_down = $total - $rating_up;
	        $post_rating = '№ '.$post_id;
	
	        if ($ps_rating['rating'] != NULL) {
                $rating_post_rates = ' <b>'.$ps_rating['rating'].' [+'.$rating_up.' | -'.$rating_down.']</b>';
	        } else {
		        $rating_post_rates = ' <b>0</b>';
	        }

	    } else {
		    $post_rating = '';
		    $rating_post_rates = ' <b>0</b>';
			$total = 0;
	    }
	
$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array(sprintf($lang_rating['Rating']), forum_link($forum_url['rating'])),
	sprintf($lang_rating['Rating of post'], $post_rating)
);

$forum_page['main_head'] = end($forum_page['crumbs']);

define('FORUM_PAGE', 'rating-post_rating');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

?>  
<div class="main-head">
	<h2 class="hn"><span><?php echo $forum_page['main_head'] ?></span><span style="float:right; margin-right:-10em;"><?php echo $lang_rating['User Rating'] . $rating_post_rates ?></span></h2>
</div>
<div class="main-content main-frm">
<?php
	if ($total > 0) {
		$query = array(
		    'SELECT'	=> 'r.post_id, r.rating, r.updated_at, u.id AS user_id, u.username AS user',
		    'FROM'		=> 'rating AS r',
		    'JOINS'		=> array(
				array(
				    'LEFT JOIN'		=> 'users AS u',
				    'ON'		    => 'u.id=r.user_id',
			    )
		    ),
			'WHERE'		=> 'r.post_id=\''.$forum_db->escape($post_id).'\'',
	        'ORDER BY'	=> 'r.updated_at DESC',
			'LIMIT'		=> $forum_page['start_from'].', '.$max_items
	    );
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
?>
    <div class="ct-group">
		<table>
			<thead>
				<tr>
				    <th class="tc0" scope="col"><?php echo $lang_rating['Voted'] ?></th>
					<th class="tc4" scope="col" style="width:5em; text-align:center;"><?php echo $lang_rating['Mark'] ?></th>
					<th class="tc5" scope="col" style="width:10.4em;"><?php echo $lang_rating['Date'] ?></th>
				</tr>
        	</thead>
			<tbody>	
<?php
		    $i = isset($_GET['p']) ? $max_items * ($forum_page['page']-1) : '0';
		    while ( $rating = $forum_db->fetch_assoc($result) )
		    {
			    if (empty($rating['user'])) {$username = $lang_rating['User deleted'];} elseif ($rating['user'] == 'Guest') {$username = $lang_rating['Guest'];} else {$username = '<a href="'.forum_link($forum_url['user'], $rating['user_id']).'">'.$rating['user'].'</a>';}

			    echo '
			        <tr>
				        <td class="tc0">'.$username.'</td>
				        <td class="tc4" style="text-align:center;">'.$rating['rating'].'</td>
				        <td class="tc5">'.format_time($rating['updated_at']).'</td>
				    </tr>';

	            $i++;
		    }	

            if ($total <= $max_items) {
				$total_rates = $lang_rating['Total rates'].'<b> '.$total.'</b>';
			} else {
				$total_rates = '<b>'.$i.' </b>'.$lang_rating['Marks from'].'<b> '.$total.'</b>';
			}		
?>
		    </tbody>
		</table>
	</div>
	<div class="main-head">
        <h2 class="hn"><span><?php echo $total_rates ?></span></h2>
    </div>
</div>
<?php
    } else {
?>
    <div class="ct-box" style="background:#FEFFE6 none repeat scroll 0% 0%;">
		<p><strong><?php if ($p_rating == 1)  echo $lang_rating['No votes in post'];  else  echo $lang_rating['Post not found']; ?></strong></p>
	</div>
</div>
<?php	
	}
	
	break;
	}
	
	case 'user':
	{
        $user_id = isset($_GET['id']) ? intval($_GET['id']) : 0;
	
	    $query_u = array(
		    'SELECT'	=> 'u.username, u.rating, u.rating_enable, u.rating_disable_adm, g.g_rating_enable',
		    'FROM'		=> 'users AS u',
			'JOINS'		=> array(
			    array(
				    'LEFT JOIN'	 => 'groups AS g',
				    'ON'		 => 'g.g_id=u.group_id'
			    ),
		    ),
		    'WHERE'		=> 'u.id=\''.$forum_db->escape($user_id).'\''
	    );
	    $result_u = $forum_db->query_build($query_u) or error(__FILE__, __LINE__);
		$u_rating = $forum_db->num_rows($result_u);
		
		if ($u_rating == 1) {
	        $ur_rating = $forum_db->fetch_assoc($result_u);

	        if ($ur_rating['username'] && $ur_rating['username'] != 'Guest') {
	            $query = array(
		            'SELECT'	=> 'r.id',
		            'FROM'		=> 'users AS u',
		            'JOINS'		=> array(
					    array(
				            'LEFT JOIN'	 => 'groups AS g',
				            'ON'		 => 'g.g_id=u.group_id'
			            ),
			            array(
				            'LEFT JOIN'	 => 'posts AS p',
				            'ON'		 => 'p.poster_id=u.id',
			            ),
		                array(
				            'LEFT JOIN'	 => 'rating AS r',
				            'ON'		 => 'r.post_id=p.id',
			            )
		            ),
//	                'WHERE'		=>	'u.id = '.$user_id
			        'WHERE'	    => '(u.id='.$user_id.' AND g.g_rating_enable = 1 AND u.rating_enable = 1 AND u.rating_disable_adm = 0 AND p.rating IS NOT NULL)'
	            );
	            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	            $total = $forum_db->num_rows($result);
				
				$forum_page['num_pages'] = ceil($total / $max_items);
	            $forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
	            $forum_page['start_from'] = $max_items * ($forum_page['page'] - 1);
	            $forum_page['finish_at'] = min(($forum_page['start_from'] + $max_items), ($total));
	            $forum_page['items_info'] = generate_items_info($lang_rating['Marks from'], ($forum_page['start_from'] + 1), $total);
	            if ($forum_page['num_pages'] > 1)
		            $forum_page['page_post']['paging'] = '<p class="paging"><span class="pages">'.$lang_rating['Pages'].'</span> '.paginate($forum_page['num_pages'], $forum_page['page'], str_replace($base_url,"",forum_link($forum_url['rating_user'], $user_id)), ' ').'</p>';

	            $query = array(
		            'SELECT'	=> 'SUM(r.rating) as rating, COUNT(p.id) as count_posts',
		            'FROM'		=> 'users AS u',
		            'JOINS'		=> array(
					    array(
				            'LEFT JOIN'	 => 'groups AS g',
				            'ON'		 => 'g.g_id=u.group_id'
			            ),
			            array(
				            'LEFT JOIN'	 => 'posts AS p',
				            'ON'		 => 'p.poster_id=u.id',
			            ),
		                array(
				            'LEFT JOIN'	 => 'rating AS r',
				            'ON'		 => 'r.post_id=p.id',
			            )
		            ),
		            'WHERE'		=>  'u.id=\''.$forum_db->escape($user_id).'\' AND g.g_rating_enable = 1 AND u.rating_enable = 1 AND u.rating_disable_adm = 0 AND r.rating = 1'
	            );
	            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	            $up = $forum_db->fetch_assoc($result);

	            $rating_up = $up['rating'];
	            $rating_down = $total - $rating_up;
		        $username = $ur_rating['username'];
	
	            if ($up['count_posts'] > 0) {
                    $rating_user_rates = ' <b>'.$ur_rating['rating'].' [+'.$rating_up.' | -'.$rating_down.']</b>';
	            } else {
		            $rating_user_rates = ' <b>0</b>';
	            }

	        } else {
		        $username = '';
		        $rating_user_rates = ' <b>0</b>';
				$total = 0;
			}
		} else {
			$username = '';
		    $rating_user_rates = ' <b>0</b>';
			$total = 0;
		}
	
$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array(sprintf($lang_rating['Rating']), forum_link($forum_url['rating'])),
	sprintf($lang_rating['Rating of user'], $username)
);

$forum_page['main_head'] = end($forum_page['crumbs']);

define('FORUM_PAGE', 'rating-user_rating');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

?>  
<div class="main-head">
	<h2 class="hn"><span><?php echo $forum_page['main_head'] ?></span><span style="float:right; margin-right:-10em;"><?php echo $lang_rating['User Rating'] . $rating_user_rates ?></span></h2>
</div>
<div class="main-content main-frm">
<?php
	if ($total > 0) {
		$query = array(
		    'SELECT'	=> 'r.post_id, r.rating, r.updated_at, t.subject AS topic_title, ur.id AS user_id, ur.username AS user',
		    'FROM'		=> 'users AS u',
		    'JOINS'		=> array(
			    array(
				    'LEFT JOIN'		=> 'posts AS p',
				    'ON'		    => 'p.poster_id=u.id',
			    ),
			    array(
				    'LEFT JOIN'		=> 'topics AS t',
				    'ON'		    => 't.id=p.topic_id',
			    ),
				array(
				    'LEFT JOIN'		=> 'rating AS r',
				    'ON'		    => 'r.post_id=p.id',
			    ),
				array(
				    'LEFT JOIN'		=> 'users AS ur',
				    'ON'		    => 'r.user_id=ur.id',
			    )
		    ),
//			'WHERE'		=>	'u.id = '.$user_id,
			'WHERE'	    =>  '(u.id='.$user_id.' AND p.rating IS NOT NULL)',
	        'ORDER BY'	=>  'r.updated_at DESC',
			'LIMIT'		=>  $forum_page['start_from'].', '.$max_items
	    );
	    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
?> 
    <div class="ct-group">
		<table>
			<thead>
				<tr>
				    <th class="tc0" scope="col" style="width:20em;"><?php echo $lang_rating['Voted'] ?></th>
					<th class="tc4" scope="col" style="width:5em; text-align:center;"><?php echo $lang_rating['Mark'] ?></th>
					<th class="tc1" scope="col"><?php echo $lang_rating['For post'] ?></th>
					<th class="tc5" scope="col" style="width:10.4em;"><?php echo $lang_rating['Date'] ?></th>
				</tr>
        	</thead>
			<tbody>	
<?php
		    $i = isset($_GET['p']) ? $max_items * ($forum_page['page']-1) : '0';
		    while ( $rating = $forum_db->fetch_assoc($result) )
		    {
			    if (empty($rating['user'])) {$username = $lang_rating['User deleted'];} elseif ($rating['user'] == 'Guest') {$username = $lang_rating['Guest'];} else {$username = '<a href="'.forum_link($forum_url['user'], $rating['user_id']).'">'.$rating['user'].'</a>';}

			    echo '
			        <tr>
				        <td class="tc0">'.$username.'</td>
				        <td class="tc4" style="text-align:center;">'.$rating['rating'].'</td>
				        <td class="tc1"><a href="'.forum_link($forum_url['post'], $rating['post_id']).'" title="'.$rating['topic_title'].'">'.$rating['topic_title'].'</a></td>
				        <td class="tc5">'.format_time($rating['updated_at']).'</td>
				    </tr>';

	        $i++;
		    }
			
		    if ($total <= $max_items) {
				$total_rates = $lang_rating['Total rates'].'<b> '.$total.'</b>';
			} else {
				$total_rates = '<b>'.$i.' </b>'.$lang_rating['Marks from'].'<b> '.$total.'</b>';
			}		
?>
		    </tbody>
		</table>
	</div>
	<div class="main-head">
        <h2 class="hn"><span><?php echo $total_rates ?></span></h2>
    </div>
</div>
<?php
    } else {
?>
    <div class="ct-box" style="background:#FEFFE6 none repeat scroll 0% 0%;">
		<p><strong><?php if ($u_rating == 1 && ($ur_rating['g_rating_enable'] == '0' || $ur_rating['rating_enable'] == '0' || $ur_rating['rating_disable_adm'] == '1')) echo $lang_rating['User rating disabled']; elseif ($u_rating == 1 && $ur_rating['username'] && $ur_rating['username'] != 'Guest') echo $lang_rating['User not have posts for vote'];  else echo $lang_rating['User not found']; ?></strong></p>
	</div>
</div>
<?php	
	}
	
	break;
	}
}

$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';